"use strict";YUI.add("juju-env-sandbox",function(Y){var sandboxModule=Y.namespace("juju.environments.sandbox");var models=Y.namespace("juju.models");var CLOSEDERROR="INVALID_STATE_ERR : Connection is closed.";function ClientConnection(config){ClientConnection.superclass.constructor.apply(this,arguments)}ClientConnection.NAME="sandbox-client-connection";ClientConnection.ATTRS={juju:{},socket_url:{}};Y.extend(ClientConnection,Y.Base,{initializer:function initializer(){this.connected=false;this.readyState=1},onmessage:function onmessage(event){},receiveNow:function receiveNow(data,failSilently){if(this.connected){this.onmessage({data:Y.JSON.stringify(data)})}else if(!failSilently){throw CLOSEDERROR}},receive:function receive(data){if(this.connected){Y.soon(this.receiveNow.bind(this,data,true))}else{throw CLOSEDERROR}},send:function send(data){if(this.connected){this.get("juju").receive(Y.JSON.parse(data))}else{throw CLOSEDERROR}},onopen:function onopen(){},open:function open(){if(!this.connected){this.connected=true;this.get("juju").open(this);this.onopen()}},onclose:function onclose(){},close:function close(){if(this.connected){this.connected=false;this.get("juju").close();this.onclose()}}});sandboxModule.ClientConnection=ClientConnection;sandboxModule.facades=[{name:"AllWatcher",versions:[1]},{name:"Annotations",versions:[2]},{name:"Application",versions:[1]},{name:"Charms",versions:[2]},{name:"Client",versions:[1]},{name:"ModelManager",versions:[2]},{name:"Pinger",versions:[1]}];function GoJujuAPI(config){GoJujuAPI.superclass.constructor.apply(this,arguments)}GoJujuAPI.NAME="sandbox-go-juju-api";GoJujuAPI.ATTRS={state:{},socket_url:{},client:{},nextRequestId:{},deltaInterval:{value:1e3}};Y.extend(GoJujuAPI,Y.Base,{initializer:function initializer(){this.connected=false;this.wsFailureCount=0},open:function open(client){if(!this.connected){this.connected=true;this.set("client",client)}else if(this.get("client")!==client){throw"INVALID_STATE_ERR : Connection is open to another client."}},close:function close(){if(this.connected){this.connected=false;this.set("client",undefined)}},destructor:function destructor(){this.close()},receive:function receive(data){if(this.connected){var client=this.get("client");var key="handle"+data.type+data.request;if(!this[key]){console.error(key+" has not yet been implemented in the sandbox.\n            You can add the method in sandbox.js.");return}this[key](data,client,this.get("state"))}else{throw CLOSEDERROR}},handleAdminLogin:function handleAdminLogin(data,client,state){data.error=!state.login(data.params["auth-tag"],data.params.credentials);data.response={facades:sandboxModule.facades,"user-info":{"read-only":false}};client.receive(data)},handlePingerPing:function handlePingerPing(data,client,state){client.receive({"request-id":data["request-id"],response:{}})},handleClientModelInfo:function handleClientModelInfo(data,client,state){client.receive({"request-id":data["request-id"],response:{"provider-type":state.get("providerType"),"default-series":state.get("defaultSeries"),name:"sandbox"}})},handleClientModelGet:function handleClientModelGet(data,client,state){client.receive({"request-id":data["request-id"],response:{config:{"maas-server":state.get("maasServer")}}})},handleModelManagerCreateModel:function handleModelManagerCreateModel(data,client,state){console.log("Creating models is not supported in the sandbox.")},handleClientDestroyModel:function handleClientDestroyModel(data,client,state){console.log("Destroying models is not supported in the sandbox.")},handleModelManagerListModels:function handleModelManagerListModels(data,client,state){client.receive({"request-id":data["request-id"],response:{"user-models":[{name:"sandbox",uuid:"sandbox1","owner-tag":"user-admin","last-connection":"today"}]}})},handleModelManagerConfigSkeleton:function handleModelManagerConfigSkeleton(data,client,state){client.receive({"request-id":data["request-id"],response:{"owner-tag":"user-admin",config:{attr1:"value1",attr2:"value2",name:"sandbox","authorized-keys":"ssh-rsa INVALID","access-key":"access!","secret-key":"secret!"}}})},_deltaWhitelist:{application:{name:"id",exposed:"exposed","charm-url":"charm",life:"life",constraints:function constraints(attrs){var constraints=attrs.constraints||{};var tags=constraints.tags;if(tags){constraints.tags=tags.split(",")}return constraints},config:"config",subordinate:"subordinate"},machine:{id:"id",addresses:"addresses","instance-id":"instance_id","agent-status":function agentStatus(attrs){return{current:attrs.agent_state,message:attrs.agent_state_info,data:attrs.agent_state_data}},"hardware-characteristics":function hardwareCharacteristics(attrs){var hardware=attrs.hardware||{};return{arch:hardware.arch,"cpu-cores":hardware.cpuCores,"cpu-power":hardware.cpuPower,mem:hardware.mem,"root-disk":hardware.disk}},jobs:"jobs",life:"life",series:"series","supported-containers":"supportedContainers","supported-containers-known":function supportedContainersKnown(){return true}},unit:{name:"id",application:"service",series:function series(attrs,self){var db=self.get("state").db;var application=db.services.getById(attrs.service);if(application){var charm=db.charms.getById(application.get("charm"));return charm.get("series")}else{return null}},"charm-url":function charmUrl(attrs,self){var db=self.get("state").db;var application=db.services.getById(attrs.service);if(application){return application.get("charm")}else{return null}},"public-address":"public_address","private-address":"private_address","machine-id":"machine",ports:"open_ports","agent-status":function agentStatus(attrs){return{current:"idle",message:"",data:{}}},"workload-status":function workloadStatus(attrs){return{current:"idle",message:"",data:{}}},subordinate:"subordinate"},relation:{key:"relation_id",endpoints:function endpoints(relation,goAPI){var result=[];if(relation.endpoints.length===1){return}relation.endpoints.forEach(function(endpoint,index){result.push({relation:{name:endpoint[1].name,role:index?"server":"client",interface:relation.type,scope:relation.scope},"application-name":endpoint[0]})});return result}},annotation:{tag:function tag(entity){return entity.id},annotations:function annotations(entity){return entity.annotations}}},_getDeltaAttrs:function _getDeltaAttrs(attrs,whitelist){if(attrs.getAttrs){attrs=attrs.getAttrs()}var filtered={},self=this;Y.each(whitelist,function(value,key){if(typeof value==="string"){filtered[key]=attrs[value]}else if(typeof value==="function"){filtered[key]=value(attrs,self)}});return filtered},_prepareDelta:function _prepareDelta(){var self=this;var state=this.get("state");var deltas=[];var changes=state.nextChanges();if(changes&&changes.error){changes=null}if(changes){Y.each(this._deltaWhitelist,function(whitelist,changeType){var collectionChanges=changes[changeType+"s"];for(var key in collectionChanges){var change=collectionChanges[key];var attrs=self._getDeltaAttrs(change[0],whitelist);var action=change[1]?"change":"remove";var delta=[changeType,action,attrs];deltas.push(delta)}})}return deltas},_prepareAnnotations:function _prepareAnnotations(){var state=this.get("state");var deltas=[];var annotations=state.nextAnnotations();if(annotations&&annotations.error){annotations=null}if(annotations){Y.each(this._deltaWhitelist,function(whitelist,changeType){Y.each(annotations[changeType+"s"],function(model,key){var attrs=models.getAnnotations(model);var tag=this.modelToTag(model);deltas.push(["annotation","change",{tag:tag,annotations:attrs}])},this)},this)}return deltas},modelToTag:function modelToTag(model){var name=model.name;if(name==="serviceUnit"){name="unit"}else if(name==="service"){name="application"}else if(name==="environment"){return"model"}return name+"-"+(model.id||model.get("id"))},sendDelta:function sendDelta(){var nextRequestId=this.get("nextRequestId");if(nextRequestId){var deltas=this._prepareDelta();var annotations=this._prepareAnnotations();if(deltas.length||annotations.length){this.get("client").receive({"request-id":this.get("nextRequestId"),response:{deltas:deltas.concat(annotations)}});this.set("nextRequestId",undefined)}}},handleClientWatchAll:function handleClientWatchAll(data,client,state){client.receive({"request-id":data["request-id"],response:{AllWatcherId:42}})},handleAllWatcherNext:function handleAllWatcherNext(data,client,state){this.set("nextRequestId",data["request-id"]);clearInterval(this.deltaIntervalId);this.deltaIntervalId=setInterval(this.sendDelta.bind(this),this.get("deltaInterval"))},handleAllWatcherStop:function handleAllWatcherStop(data,client,state){clearInterval(this.deltaIntervalId);client.receive({"request-id":data["request-id"],response:{}})},_basicReceive:function _basicReceive(request,client,result){var response={"request-id":request["request-id"],response:{}};if(result.error){response.error=result.error}client.receive(response)},handleClientAddCharm:function handleClientAddCharm(data,client,state){client.receive({"request-id":data["request-id"],response:{}})},handleClientAddCharmWithAuthorization:function handleClientAddCharmWithAuthorization(data,client,state){this.handleClientAddCharm(data,client,state)},handleApplicationDeploy:function handleApplicationDeploy(data,client,state){var callback=function callback(result){var res={};if(result.error){res.error=result.error}client.receive({"request-id":data["request-id"],response:{results:[res]}})};var params=data.params.applications[0];state.deploy(params["charm-url"],callback,{name:params.application,config:params.config,configYAML:params["config-yaml"],constraints:params.constraints,unitCount:params["num-units"]})},handleClientAddMachines:function handleClientAddMachines(data,client,state){var params=data.params.params.map(function(machineParam){return{jobs:machineParam.jobs,series:machineParam.series,parentId:machineParam["parent-id"],containerType:machineParam["container-type"],constraints:machineParam.constraints}});var response=state.addMachines(params);var machines=response.machines.map(function(data){var error=null;if(data.error){error={code:"",message:data.error}}return{machine:data.name||"",error:error}});client.receive({"request-id":data["request-id"],error:response.error,response:{machines:machines}})},handleClientDestroyMachines:function handleClientDestroyMachines(data,client,state){var params=data.params;var response=state.destroyMachines(params["machine-names"],params.force);this._basicReceive(data,client,response)},handleApplicationDestroy:function handleApplicationDestroy(data,client,state){var result=state.destroyApplication(data.params.application);this._basicReceive(data,client,result)},handleApplicationDestroyUnits:function handleApplicationDestroyUnits(data,client,state){var res=state.removeUnits(data.params["unit-names"]);this._basicReceive(data,client,res)},handleCharmsCharmInfo:function handleCharmsCharmInfo(data,client,state){state.getCharm(data.params.url,function(result){if(result.error){this._basicReceive(data,client,result)}else{result=result.result;var convertedData={"request-id":data["request-id"],response:{config:result.options,meta:{description:result.description,format:result.format,name:result.name,oeers:result.peers,provides:result.provides,requires:result.requires,subordinate:result.is_subordinate,summary:result.summary},url:result.url,revision:result.revision}};client.receive(convertedData)}}.bind(this))},handleApplicationUpdate:function handleApplicationUpdate(data,client,state){var result;var params=data.params;var application=params.application;var callback=function(result){this._basicReceive(data,client,result)}.bind(this);if(params.settings){result=state.setConfig(application,params.settings);if(result.error){callback(result)}}if(params.constraints){result=state.setConstraints(application,params.constraints);if(result.error){callback(result)}}if(params["charm-url"]){state.setCharm(application,params["charm-url"],params["force-charm-url"],params["force-series"],callback);return}callback({})},handleClientResolved:function handleClientResolved(data,client,state){var result=state.resolved(data.params["unit-name"]);this._basicReceive(data,client,result)},handleAnnotationsSet:function handleAnnotationsSet(data,client,state){var args=data.params.annotations[0];var entityId=/^(application|unit|machine|model)-([^ ]*)$/.exec(args.entity)[2];var result=state.updateAnnotations(entityId,args.Annotations);this._basicReceive(data,client,result)},handleApplicationGet:function handleApplicationGet(data,client,state){var reply=state.getApplication(data.params.application);var response={"request-id":data["request-id"]};if(reply.error){response.error=reply.error;client.receive(response)}else{var charmName=reply.result.charm;state.getCharm(charmName,function(payload){var charmData=payload.result;var formattedConfig={};var backendConfig=reply.result.options||reply.result.config;Y.Object.each(charmData.options,function(value,key){formattedConfig[key]=charmData.options[key];if(backendConfig[key]){formattedConfig[key].value=backendConfig[key]}else{formattedConfig[key].value=charmData.options[key]["default"]}});response.response={application:data.params.application,charm:charmName,config:formattedConfig,constraints:reply.result.constraints};client.receiveNow(response)})}},handleApplicationAddUnits:function handleApplicationAddUnits(data,client,state){var args=data.params;var toMachine;if(args.placement&&args.placement[0]){toMachine=args.placement[0].Directive}var reply=state.addUnit(args.application,args["num-units"],toMachine);var units=[];if(!reply.error){units=reply.units.map(function(u){return u.id})}client.receive({"request-id":data["request-id"],error:reply.error,response:{units:units}})},handleApplicationExpose:function handleApplicationExpose(data,client,state){var result=state.expose(data.params.application);this._basicReceive(data,client,result)},handleApplicationUnexpose:function handleApplicationUnexpose(data,client,state){var result=state.unexpose(data.params.application);this._basicReceive(data,client,result)},handleApplicationAddRelation:function handleApplicationAddRelation(data,client,state){var stateData=state.addRelation(data.params.endpoints[0],data.params.endpoints[1],false);var resp={"request-id":data["request-id"]};if(stateData===false){resp.error="Unable to create relation";client.receive(resp);return}if(stateData.error){resp.error=stateData.error;client.receive(resp);return}var respEndpoints={},stateEpA=stateData.endpoints[0],stateEpB=stateData.endpoints[1],epA={name:stateEpA[1].name,role:"requirer",scope:stateData.scope,interface:stateData["interface"]},epB={name:stateEpB[1].name,role:"provider",scope:stateData.scope,interface:stateData["interface"]};respEndpoints[stateEpA[0]]=epA;respEndpoints[stateEpB[0]]=epB;resp.response={endpoints:respEndpoints};client.receive(resp)},handleApplicationDestroyRelation:function handleApplicationDestroyRelation(data,client,state){var result=state.removeRelation(data.params.endpoints[0],data.params.endpoints[1]);this._basicReceive(data,client,result)},handleClientGetBundleChanges:function handleClientGetBundleChanges(data,client,state){var ws=new Y.ReconnectingWebSocket(this.get("socket_url"));ws.onopen=this._changeSetWsOnOpen.bind(this,ws,data);ws.onmessage=this._changeSetWsOnMessage.bind(this,ws,data,client);ws.onerror=this._changeSetWsOnError.bind(this,ws,data,client)},_changeSetWsOnOpen:function _changeSetWsOnOpen(ws,data){ws.send(JSON.stringify(data))},_changeSetWsOnError:function _changeSetWsOnError(ws,data,client,response){this.wsFailureCount+=1;if(this.wsFailureCount===3){ws.close();this._basicReceive(data,client,{error:"Unable to connect to bundle processor."})}},_changeSetWsOnMessage:function _changeSetWsOnMessage(ws,data,client,response){var responseData=JSON.parse(response.data);if(responseData.Error==="not implemented (sandbox mode)"){responseData["error-code"]="not implemented"}client.receive({"request-id":data["request-id"],error:responseData.Error,"error-code":responseData.ErrorCode,response:responseData.Response});ws.close()}});sandboxModule.GoJujuAPI=GoJujuAPI},"0.1.0",{requires:["base","js-yaml","json-parse","juju-env-api","reconnecting-websocket","timers"]});